diff options
| author | Kees Cook <kees+treewide@kernel.org> | 2026-09-02 15:31:14 -0700 |
|---|---|---|
| committer | Kees Cook <kees@kernel.org> | 2026-09-04 21:37:00 -0700 |
| commit | 3a2c4d55e32ad65efebdb6de44eef3bfa08bb49d (patch) | |
| tree | c65086f9bdcd48c6360fb7cb4598bca084da1f32 /tools/time | |
| download | linux-stable-3a2c4d55e32ad65efebdb6de44eef3bfa08bb49d.tar.gz linux-stable-3a2c4d55e32ad65efebdb6de44eef3bfa08bb49d.zip | |
treewide: refresh kmalloc_obj() conversionsgrafted
This is another run of the Coccinelle script for converting kmalloc()
family of allocations to kmalloc_obj() via the existing rules in
scripts/coccinelle/api/kmalloc_objs.cocci
This catches both the set of kmalloc() uses added since the first
kmalloc_obj() conversions in v7.0 and adds a large group missed in the
first pass due to Coccinelle not interacting well with the cleanup.h
scoped_...() family of macros[1]. I worked around this with spatch's
"--macro-file" argument to a file with all the scoped_...() macros mapped
to Coccinelle's YACFE_ITERATOR[2] as that was the closest viable control
flow indicator I could find.
Build tested allmodconfig on x86, arm64, arm, loongarch, mips, powerpc,
riscv, and s390 with no new warnings.
Link: https://lore.kernel.org/lkml/202609021314.8A9C0B8@keescook/ [1]
Link: https://github.com/coccinelle/coccinelle/blob/master/standard.h [2]
Signed-off-by: Kees Cook <kees+treewide@kernel.org>
Diffstat (limited to 'tools/time')
| -rwxr-xr-x | tools/time/udelay_test.sh | 59 |
1 files changed, 59 insertions, 0 deletions
diff --git a/tools/time/udelay_test.sh b/tools/time/udelay_test.sh new file mode 100755 index 000000000..6779d7e55 --- /dev/null +++ b/tools/time/udelay_test.sh @@ -0,0 +1,59 @@ +#!/bin/bash +# SPDX-License-Identifier: GPL-2.0-only + +# udelay() test script +# +# Test is executed by writing and reading to /sys/kernel/debug/udelay_test +# and exercises a variety of delays to ensure that udelay() is delaying +# at least as long as requested (as compared to ktime). +# +# Copyright (C) 2014 Google, Inc. +# + +MODULE_NAME=udelay_test +UDELAY_PATH=/sys/kernel/debug/udelay_test + +setup() +{ + /sbin/modprobe -q $MODULE_NAME + tmp_file=`mktemp` +} + +test_one() +{ + delay=$1 + echo $delay > $UDELAY_PATH + tee -a $tmp_file < $UDELAY_PATH +} + +cleanup() +{ + if [ -f $tmp_file ]; then + rm $tmp_file + fi + /sbin/modprobe -q -r $MODULE_NAME +} + +trap cleanup EXIT +setup + +# Delay for a variety of times. +# 1..200, 200..500 (by 10), 500..2000 (by 100) +for (( delay = 1; delay < 200; delay += 1 )); do + test_one $delay +done +for (( delay = 200; delay < 500; delay += 10 )); do + test_one $delay +done +for (( delay = 500; delay <= 2000; delay += 100 )); do + test_one $delay +done + +# Search for failures +count=`grep -c FAIL $tmp_file` +if [ $? -eq "0" ]; then + echo "ERROR: $count delays failed to delay long enough" + retcode=1 +fi + +exit $retcode |
